//if using any custom parameters, note them here what they're used for
// eg. param 1: sets font size

(function() {
    window.bazingaApp.views.abstractModuleView = window.bazingaApp.views.appView.extend({

        beforePageLoad: function() {
            var self = this;

            var scenarioPoints = 0;
            var scenarioGoal = 0;
            self.promptAvailable = true;

            var allScenariosComplete = false;
            var scenarioComplete = false;

            self.scrolling = false;
            self.canAnimate = true;

            var scrollY;

            pageNum = parseInt(self.getQueryVariable("p")) || 0;
            window.bazingaApp.models.navigation.setParam4(pageNum);

            $(".pageBlock").each(function() {
                var thisPageNum = $(this).attr("data-pageNum");

                if (thisPageNum == 0) {
                    $(this).css("z-index", "10");
                }
                console.log(thisPageNum + "/" + pageNum);
                if (parseInt(thisPageNum) <= pageNum) {
                    $(this).show();
                    $("[data-num=" + thisPageNum + "]").show();

                    $(window).trigger('resize');
                    console.log("show " + thisPageNum);
                }
            });


            if ($("body").hasClass("assessment")) {
                $(".backBtn").remove();
            }

            if (self.isiOS()) {
                $("html").addClass("iOS");
                //$("html").css("width", window.innerWidth);

                //$(".container1").css("width", window.innerWidth);
                $(".container1").css("height", window.innerHeight);

                //$("html").css("width",$("html").width());
            } else {

                $(".callOut").not(".noFade").attr("data-scroll-class", "fadeIn");
                $(".whatif").attr("data-scroll-class", "fadeIn");
            }
            /*$(".hangLeft").attr("data-scroll-class","slideUp");*/

            //dodgy fix for no menu

            if ($("#js-dropdown li").length == 1) {
                location.reload();
            }

            //last topic course completion

            if ($("body").hasClass("lastPage")) {

                var checkModComplete = setInterval(function() {
                    console.log("check " + window.bazingaApp.models.api.getCourseCompletion());
                    if ($("#footerContainer").is(':visible')) {
                        window.bazingaApp.models.api.setCourseStatus("completed");

                        console.log("last page of last topic, complete module");
                        if (window.bazingaApp.models.api.getCourseCompletion() == "completed") {
                            console.log("module complete");
                            clearInterval(checkModComplete);
                        }
                    }

                }, 1000);


            }

            //next topic in footer

            if (!$("body").hasClass("lastPage") && !$("body").hasClass("pHome")) {
                var nextTopicNum = parseInt($("body").attr("data-pre-id")) + 1;

                console.log(nextTopicNum);

                var nexttopicName = window.bazingaApp.models.api.getNavForScreen("g" + nextTopicNum).title;
                console.log("topicNAME:");
                console.log(nextTopicNum);
                console.log(nexttopicName);
                $("#topicName").html(nexttopicName);
                $(".continueBtn").attr("data-goto", nextTopicNum + "1");
            }

            if (pageNum != 0) {

                var lastPageBlock = $('.pageBlock[data-pageNum=' + pageNum + ']');

                //console.log(lastPageBlock);
                if ($(lastPageBlock).offset.top == undefined) {
                    lastPageBlock = $('.pageBlock:visible:last');
                }

                if (!$("html").hasClass("iOS")) {
                    $('html, body').animate({
                        scrollTop: $(lastPageBlock).offset().top
                    }, 'slow', function() { $(window).trigger('resize') });
                }

                //if next page not pageblock, show footer
                if (!$('.pageBlock[data-pageNum=' + pageNum + ']').next().hasClass("pageBlock") && $('.pageBlock[data-pageNum=' + pageNum + ']').hasClass("nonePage")) {
                    $("#footerContainer").show();
                }
            } else {
                $("[data-pageNum='1']").show();
                $(".parallax[data-num='1']").show();
            }

            //true false question 2-9

            /*if($(".pairBtn").length > 0){
                $(".pairBtn").on('click ',function() { //need the  for ipad

                    console.log("test");

                    var pairFeedback= '<span class="pairFeedback">That’s right.</span> ';

                    if($(this).find('.icon-tick[src$="../img/tick.png"]').length == 0){
                        //console.log("wrong");
                        pairFeedback= '<span class="pairFeedback">That’s not the best answer.</span> ';
                    }

                    var overlay = $($(this).attr("data-reveal-data"));

                    overlay.find('.pairFeedback').remove();
                    overlay.find("h3").prepend(pairFeedback);

                });

            }*/

            var correctSelected = false;

            $(".checkbox").on('click touchend', function(e) {

                var checkboxContainer = $(this).parent();
                if (checkboxContainer.hasClass("scenarioQuestion")) {

                    var correctNum = $(checkboxContainer).attr("data-correct") || $(checkboxContainer).attr("data-cb-correct");
                    var thisNum = $(this).attr("data-cbid");

                    if (thisNum == correctNum) {
                        if ($(this).hasClass("is-selected")) {
                            scenarioPoints = scenarioPoints + 1;
                            correctSelected = true;
                        } else {
                            scenarioPoints = scenarioPoints - 1;
                        }
                        console.log("score " + scenarioPoints + " / " + scenarioGoal);
                    } else {

                        //selected non correct answer
                        if (correctSelected) {
                            correctSelected = false;
                            scenarioPoints = scenarioPoints - 1;
                        }

                    }

                }
            });

            $("[type='submit']").on('click touchend', function(e) {

                console.log("submit");
                correctSelected = false;

                console.log(scenarioPoints + "/" + scenarioGoal + " .allScenariosComplete? " + allScenariosComplete);

                //got all questions in a scenario correct
                if (scenarioPoints >= scenarioGoal) {
                    scenarioComplete = true;
                    $(".finBtn").show();
                    $(".retryBtn").hide();
                    console.log("complete, scenario complete: " + scenarioComplete);

                } else {
                    $(".finBtn").hide();
                    $(".retryBtn").show();
                }

                console.log("allScenariosComplete ? " + allScenariosComplete + ". 1 complete? " + scenarioComplete);
                //all scenarios done
                if (allScenariosComplete || scenarioComplete) {
                    $(".finBtn").css("display", "inline-block");
                    if (allScenariosComplete) {
                        $(".retryBtn").hide();
                    } else {
                        $(".retryBtn").css("display", "inline-block");
                    }
                }

                //copy selection into feedback
                var question = $(this).parent().prev();

                $(question.attr("data-feedback-show-selector")).find(".answerContainer").html(question.html());
                $(question.attr("data-feedback-show-selector")).find(".is-disabled").removeClass("is-disabled");

                //console.log(question);
                //console.log(question.attr("data-feedback-show-selector"));

            });

            $(".imgBtn").on('click touchend', function(e) {
                console.log("imgBtn-------------");
                $(this).closest(".pageBlock").find(".imgBtn").removeClass("current");
                if (!$(this).hasClass("scenarioBtn")) {
                    $(this).addClass("current");

                    //pause all video

                    setTimeout(function() {

                        $('video:hidden').each(function() {
                            $(this).get(0).pause();
                        });

                    }, 1500);

                }
            });

            /*
            
            remove scrolling on mobile
            
            $(".imgBtn").on('touchend', function(e) {
                    
                    var thisBtn = $(this);

                    setTimeout(function() {

                        $('html,body').animate({
                            scrollTop: thisBtn.offset().top
                        }, 1000);

                    }, 1000);

            });*/

            $(".scrollBtn,.scenarioBtn").on('click touchend', function(e) {
                console.log("scroll or scenarioBtn pressed");

                if (!$("html").hasClass("iOS")) {
                    var scrollTo = $(this).attr("data-reveal-object");

                    //console.log(scrollTo);
                    setTimeout(function() {
                        $("html,body").animate({
                            scrollTop: parseInt($(scrollTo).offset().top - 20)
                        }, 1000);
                    }, 300);
                }


                if ($(this).hasClass("scenarioBtn") && !$(this).hasClass("is-disabled")) {
                    //console.log($(".scenarioBtn").length);
                    //console.log($(".scenarioBtn.is-visited").length);
                    console.log($(".scenarioBtn.is-visited").length + " of " + $(".scenarioBtn").length + " scenario btns pressed");
                    if ($(".scenarioBtn").length == $(".scenarioBtn.is-visited").length) {
                        //when pressing all the scenario btns
                        //$(".scenarioFailBtn").css("display", "block");
                        console.log("all scenario btns pressed");
                        allScenariosComplete = true;
                        console.log("trigger allScenariosComplete");
                    }

                    $(this).addClass("is-disabled");
                    $(".scenarioBtns").hide();

                    scenarioGoal = $(this).attr("data-points");
                    scenarioPoints = 0;
                    console.log(scenarioPoints + " / " + scenarioGoal);
                }
            });

            if ($(window).width() <= 767) {
                //mobile only js

                //on mobile, pop boxes don't close other ones
                $("[data-reveal-target]:not('.overlay'):not('.button-close')").removeAttr("data-reveal-target");

                //all popboxes disabled by default
                $(".popBox").addClass("u-hidden").removeClass("popBox");
                $("[data-reveal-type='popup']").removeClass("is-visited current");

            }

            //add crosses
            $(".icon-checkbox").append('<img class="icon-tick-black" alt="" src="../bazinga-framework/theme/munro/img/tick-black.png">' +
                '<img class="icon-cross-black" alt="" src="../bazinga-framework/theme/munro/img/cross-black.png">' +
                '<img class="icon-cross" alt="" src="../bazinga-framework/theme/munro/img/cross.png">');

            //unlock buttons
            $("[data-locked-until]").each(function() {
                console.log("locked until");
                console.log($(this));
                var checkBtn = $(this).attr("data-locked-until");
                console.log(checkBtn);
                if ($(checkBtn).hasClass("is-visited")) {
                    $(this).removeClass("is-disabled");
                    console.log("unlock it");
                };
            });

            if ($(window).width() <= 767 && $("body").hasClass("pHome")) {
                //mobile home page, stack them on top of each other
            } else {
                if (typeof Hammer !== 'undefined') {

                    console.log("do hammer");

                    var myElement = document.getElementById('hammerContainer');

                    // create a simple instance
                    // by default, it only adds horizontal recognizers
                    var mc = new Hammer(myElement);

                    // listen to events...

                    //var scrolling = false;

                    var containerWidth;
                    var numContainers;
                    var barWidth;
                    self.barNum = 1;
                    var onLast = false;

                    //add arrows

                    $("li:not(:last-child) .hammerItem").append('<img class="carouselArrow" src="../bazinga-framework/theme/munro/img/carousel-arrow.png" />');

                    $(window).trigger('resize');

                    mc.on("panleft panright", function(ev) { //tap press
                        console.log(ev.type + " gesture detected. " + self.scrolling);
                        if (self.scrolling == false) {
                            self.scrolling = true;
                            console.log("scrolling :" + self.scrolling);
                            if ($(".currentDate").length > 0) {

                                var currentItemFound = false;

                                if (!currentItemFound) {
                                    $('.hammerList li').each(function(i, obj) {

                                        //console.log($(this));
                                        //console.log("currentItemFound: " + currentItemFound);

                                        if ($(this).hasClass("currentItem") && !currentItemFound) {

                                            currentItemFound = true;
                                            console.log(i + ": currentItemFound :" + currentItemFound);
                                            self.barNum = i + 1;
                                            return false;
                                        }
                                    });
                                }

                                console.log("startNum " + self.barNum);
                            }

                            var currentPageNum = $(".hammerList").parents(".pageBlock").attr("data-pagenum");
                            console.log("hammer currentPageNum " + currentPageNum);

                            console.log(ev.target);
                            console.log($(ev.target));

                            if ($(ev.target).is("video") || $(ev.target).hasClass("mejs-overlay") || $(ev.target).hasClass("mejs-overlay-button") || $(ev.target).parents().hasClass("mejs-container")) {
                                self.scrolling = false;
                                return false;
                            }

                            console.log("old scrolling " + self.scrolling);

                            var currentLeft = parseInt($("#hammerContainer").css("margin-left").slice(0, -2));
                            var currentBarLeft = parseInt($(".hammerCurrent").css("margin-left").slice(0, -2));

                            var scrollAmt = containerWidth;

                            console.log("currentLeft " + currentLeft);
                            if (ev.type == "panleft") {
                                console.log("left. move right");
                                console.log($(".currentItem").find(".showVidBtn").length + "/" + $(".currentItem").find(".showVidBtn.is-visited").length);
                                //console.log(currentLeft - scrollAmt + "/" + -(numContainers - 1) * containerWidth);
                                if ($(".currentItem").find(".showVidBtn").length == $(".currentItem").find(".showVidBtn.is-visited").length) {
                                    if (currentLeft - scrollAmt >= -(numContainers - 1) * containerWidth) {
                                        self.scrolling = true;
                                        console.log("scrolling true");

                                        console.log("check last");
                                        //console.log(currentLeft - scrollAmt + "/" + -(numContainers - 1) * containerWidth);
                                        //if (currentLeft - scrollAmt <= -(numContainers - 1) * containerWidth) {
                                        if (self.barNum == (numContainers - 1)) {
                                            console.log("****last scroll");
                                            console.log($(".pageBlock .container").width() + " - " + containerWidth);
                                            scrollAmt = containerWidth - ($(".pageBlock .container").width() - containerWidth);
                                            console.log("scrollAmt " + scrollAmt);
                                            self.updatePrompt();

                                            if (!$("#hammerContainer").hasClass("timeline")) {
                                                self.updateScroll(currentPageNum);
                                            }
                                            onLast = true;
                                        }

                                        if ($("#hammerContainer").hasClass("timeline")) {
                                            scrollAmt = $(".pageBlock .container").width();
                                        }

                                        console.log("scrollAmt: " + scrollAmt);

                                        $("#hammerContainer").animate({ marginLeft: currentLeft - scrollAmt }, 500, function() { self.scrolling = false; });
                                        $(".hammerCurrent").animate({ marginLeft: currentBarLeft + barWidth }, 500);

                                        self.barNum = parseInt(self.barNum) + 1;
                                        canAnimate = true;
                                    } else {
                                        //trying to move past last slide
                                        self.scrolling = false;
                                        self.canAnimate = false;
                                        console.log("no left. scrolling is " + self.scrolling);
                                    }
                                } else {
                                    //video not pressed
                                    self.canAnimate = false;
                                    self.scrolling = false;
                                }
                            } else if (ev.type == "panright") {
                                console.log("right. move left/back");
                                if (self.barNum != 1) {
                                    self.scrolling = true;
                                    console.log("panright scrolling true");

                                    console.log(currentLeft + scrollAmt + "/" + -(numContainers - 1) * containerWidth);

                                    if (onLast) {
                                        console.log("********going from last scroll");
                                        scrollAmt = containerWidth - ($(".pageBlock .container").width() - containerWidth);
                                        console.log("scrollAmt " + scrollAmt);
                                        onLast = false;
                                    }

                                    if ($("#hammerContainer").hasClass("timeline")) {
                                        scrollAmt = $(".pageBlock .container").width();
                                    }

                                    console.log("scrollAmt: " + scrollAmt);

                                    $("#hammerContainer").animate({ marginLeft: currentLeft + scrollAmt }, 500, function() { self.scrolling = false; });
                                    $(".hammerCurrent").animate({ marginLeft: currentBarLeft - barWidth }, 500);
                                    self.barNum = parseInt(self.barNum) - 1;
                                } else {
                                    self.scrolling = false;
                                }
                            }

                            $(".hammerList > li").removeClass("currentItem");
                            var listChild = self.barNum;
                            console.log("barNum updated to " + listChild);
                            $(".hammerList li:nth-child(" + listChild + ")").addClass("currentItem");

                            if ($("#hammerContainer").hasClass("timeline")) {
                                self.updateTimeline($(".currentItem").attr("data-date"), self.barNum);
                            }

                            console.log("scrolling end: " + self.scrolling);

                        }



                    });
                }
            }

            $(window).bind('orientationchange', function(event) {
                //alert('new orientation:' + event.orientation);
                $(window).trigger('resize');
                setTimeout(function() {

                    //var newWidth = window.innerWidth;
                    var newHeight = window.innerHeight;

                    if (event.orientation == "landscape") {
                        //newWidth = window.innerHeight;
                        newHeight = window.innerWidth;
                    }

                    //$("html").css("width", newWidth);
                    $("html").css("height", newHeight);
                    //$(".container1").css("width", window.innerWidth);
                    $(".container1").css("height", newHeight);
                }, 500);

            });

            $(window).resize(function() {

                //console.log("old resize func "+barNum);
                //if(!$("#hammerContainer").hasClass("timeline")){

                if ($(window).width() <= 767 && $("body").hasClass("pHome")) {
                    //home mobile, do nothing
                } else {
                    containerWidth = $("#hammerContainer .hammerItem").outerWidth();
                    numContainers = $("#hammerContainer .hammerItem").length;

                    var percent = (1 / numContainers);
                    //console.log(numContainers);

                    //console.log(percent);
                    //console.log($(".pageBlock .container").width());
                    //console.log("hammerCurrent");

                    barWidth = $(".pageBlock .container").width() * percent;
                    //barWidth = containerWidth/numContainers;

                    $(".hammerCurrent").css("width", barWidth);

                    //console.log(containerWidth + " x " + numContainers);

                    //update containers width
                    $("#hammerContainer").css("width", (containerWidth) * numContainers);
                    //$("#hammerContainer").css("margin-left", -$( window ).width() * (barNum-1));
                    if (!self.barNum == numContainers) {
                        $("#hammerContainer").css("margin-left", -containerWidth * (self.barNum - 1));
                    }

                    //bar
                    $(".hammerCurrent").animate({ marginLeft: barWidth * (self.barNum - 1) }, 0);

                    //}

                }

                if ($(window).width() <= 767) {
                    $(".hammerList li").css("width", $(".main .container").width());
                }

            });

            //navigation

            var numPages = $(".pageBlock").length;

            var navHTML = '<ul class="u-unstyled-list">';

            for (var i = 0; i < numPages; i++) {
                navHTML = navHTML + '<li><div class="navIndicator"></div></li>';
            }

            var navHTML = navHTML + '<li><button class="u-unstyled-button topBtn"><img src="../bazinga-framework/theme/munro/img/icon-top.png"></button></li></ul>';

            if (document.getElementById("navContainer")) {
                document.getElementById("navContainer").innerHTML = navHTML;
            }

            console.log(pageNum);

            $("#navContainer ul li:nth-child(" + pageNum + ") div").addClass("currentNavIndicator");

            $(".topBtn").on('click touchend', function(e) {
                $("html, body").animate({ scrollTop: 0 }, "slow");
                return false;
            });

            //progress bar

            setInterval(function() {
                var currentProgress = window.bazingaApp.models.api.getProgress() || 0;
                var allTrackables = window.bazingaApp.models.api.getAllTrackablePages();

                //console.log("Current progress: " + currentProgress +"/"+ allTrackables.length);

                var progressPercentage = Math.round((currentProgress / allTrackables.length) * 100);

                $(".progress .bar-current").css("width", progressPercentage + "%");
                $(".progress #percentage").html(progressPercentage + "%");
                //console.log("progress");

            }, 1000);


            $(".heading--course").html(window.bazingaApp.models.api.getCourseConfig().header);

            //window scroll

            //iphone
            //console.log(window === window.parent, this, window);
            window.addEventListener('touchend', function() {

                //self = this;
                console.log("iphone touchend/scroll " + self.promptAvailable);
                $(window).scroll();

                //on iphone trigger prompt hide on press
                if (self.promptAvailable == true && $(".scrollPrompt").is(":visible") == true) {
                    self.promptAvailable = false;

                    clearTimeout(promptTimeout);
                    var promptTimeout = setTimeout(function() {
                        console.log("iphone fade prompt");
                        self.promptAvailable = true;
                        $(".scrollPrompt").removeClass("expandUp").fadeOut(); /*console.log("test");*/
                    }, 2000);
                }

                //copy show footer code
                /*var currentPageBlock = $(".pageBlock:visible:last");
                if (!currentPageBlock.next().hasClass("pageBlock")) {
                $("#footerContainer").show();
            }*/

            });

            document.addEventListener("scroll", $(window).scroll(), false);


            /*window.addEventListener('touchstart', function() {
            //reposition scroll prompt top position
                console.log("touchstart");

                //var scrollAmt = ;

                //console.log(scrollAmt);

                //$(".scrollPrompt").css("top",$("body").scrollTop()+100);

                $(".container2").css("height", $(".iOS").innerHeight);

            });*/


            //$(window).on("touchend",function(){console.log('a')});

            $(window).scroll(function() {
                /*if($("html").hasClass("iOS")){
                    return false;
                }*/
                console.log("scroll~~");

                //animate things when scrolled into position
                var scrollAmt = parseInt($(window).scrollTop() + $(window).height() * 3 / 4);

                $('[data-scroll-class]').each(function(i, obj) {

                    //console.log($(this));
                    //console.log("test " + scrollAmt + "/" + $(this).offset().top + " : " + $(this).parents(".pageBlock").is(":visible"));
                    var $el = $(this);
                    //console.log($('[data-scroll-class]').length);

                    if (scrollAmt > $(this).offset().top && $(this).parents(".pageBlock").is(":visible") == true) {
                        var scrollClass = $(this).attr("data-scroll-class");
                        var thisDelay = $(this).attr("data-scroll-delay") * 1000 || 0;
                        console.log(scrollClass);
                        console.log(thisDelay);

                        var test = setTimeout(function() {
                            $el.removeAttr("data-scroll-class");
                            $el.addClass(scrollClass);
                            console.log("add class");
                        }, thisDelay);

                    }
                });

                //animating list

                $(".animatingList").each(function(i, obj) {
                    if (scrollAmt > $(this).offset().top && $(this).is(":visible") == true) {

                        var thisList = $(this);

                        //console.log("animatingList");

                        var num = 0;

                        var interval = setInterval(function() {

                            num = num + 1;

                            console.log(num);

                            thisList.find("li:nth-child(" + (num + 1) + ")").fadeIn();

                            if (num == thisList.children().length) {
                                clearInterval(interval);
                            }

                        }, 1000);

                    };
                });

                //console.log("scrolling.. promptAvailable: " + self.promptAvailable);
                //console.log("scrolling..");
                //$("#hammerContainer").css("width",$(".pageBlock").width);

                var scrollYpos = $(window).scrollTop();
                console.log("scrolling " + scrollY + "/" + scrollYpos);

                if (scrollY != scrollYpos || $("html").hasClass("iOS")) {
                    //console.log("scrolling");
                    scrollY = scrollYpos;

                    //pause all video
                    $('video').each(function() {
                        $(this).get(0).pause();
                    });

                    $('.parallax').each(function() {
                        var oriTop = $(this).attr("data-top");
                        //console.log($(window).scrollTop());

                        if ($(this).hasClass("defaultShow")) {
                            $(this).show();
                        }

                        /*if(oriTop == 0){
                            //move left
                            var newScroll = parseInt(($(window).scrollTop())*0.5);
                        //console.log(newScroll);
                        $(this).css('top',0);
                        $(this).css('left',newScroll+'px');
                        }else{*/
                        var newScroll = parseInt(($(window).scrollTop() - oriTop) * 0.3) + parseInt(oriTop);
                        //console.log(newScroll);
                        $(this).css('top', newScroll + 'px');
                        //}
                    });

                    var test = window.pageYOffset || document.documentElement.scrollTop;
                    if (!self.isiOS()) {
                        $('.imgParallax').each(function() {

                            var newScroll = parseInt(($(window).scrollTop() - $(this).offset().top) * 0.1);
                            //console.log(newScroll);
                            $(this).css('margin-top', newScroll + 'px');
                        });

                        $('.bgParallax').each(function() {

                            var newScroll = parseInt(($(window).scrollTop() - $(this).offset().top) * 0.07);
                            //console.log(newScroll);
                            $(this).css('background-position', 'center ' + newScroll + 'px');
                        });
                    }

                    $(window).trigger('resize');

                    //update navi indicator

                    //console.log("update nav ");
                    $(".pageBlock").each(function() {

                        var pageTop = $(this).offset().top;

                        var pageBottom = $(this).offset().top + $(this).outerHeight();

                        //if (scrollY > pageTop && scrollY < pageBottom) {
                        if (scrollYpos > pageTop && scrollYpos < pageBottom) {
                            //console.log("match "+$(this).attr("data-pagenum"));

                            var currentPageNum = parseInt($(this).attr("data-pagenum")) + 1;

                            $(".navIndicator").removeClass("currentNavIndicator");
                            $("#navContainer ul li:nth-child(" + currentPageNum + ") div").addClass("currentNavIndicator");
                        }

                    });

                    if ($("#footerContainer").is(':visible') || $("#footerContainer").length == 0) {
                        if ((window.innerHeight + window.scrollY) >= document.body.offsetHeight) {
                            //console.log("reached the bottom of the window");
                            $(".navIndicator").removeClass("currentNavIndicator");
                            var numPages = $("#navContainer ul li").length - 1;
                            //console.log(numPages);
                            $("#navContainer ul li:nth-child(" + numPages + ") div").addClass("currentNavIndicator");
                        }
                    }

                    //console.log($(".pageBlock").width());

                    //console.log($(window).scrollTop() + $(window).height()+"/"+$(document).height());

                    if ($(window).scrollTop() + $(window).height() >= $(document).height() - 500 || $("html").hasClass("iOS")) {
                        console.log("bottom reached");
                        var currentPageBlock = $(".pageBlock:visible:last");

                        if (currentPageBlock.hasClass("nonePage")) {
                            //static page, show next
                            //var self = this;
                            //self.updatePrompt("scroll");
                            //self.updateScroll();

                            console.log(currentPageBlock.attr("data-pagenum") + " nonPage trigger scroll");
                            $("#clickScroll").trigger("click");
                            return false;
                        }
                    }

                    if (self.promptAvailable == true) {
                        self.promptAvailable = false;

                        clearTimeout(promptTimeout);
                        var promptTimeout = setTimeout(function() {
                            console.log("fade prompt");
                            self.promptAvailable = true;
                            $(".scrollPrompt").removeClass("expandUp").fadeOut(); /*console.log("test");*/
                        }, 2000);
                    }

                } else {
                    console.log("same scroll");
                }

            });

            //end scroll

            $(".clickScroll,#clickScroll").on('click touchend', function(e) {
                console.log("trigger click scroll");

                var currentPageNum = $(this).parents(".pageBlock").attr("data-pagenum");

                if (!$(this).hasClass("is-disabled")) {

                    if (!$(this).hasClass("alreadyScrolled")) {
                        self.updateScroll(currentPageNum);
                    }

                    if ($(this).hasClass("imgBtn") || $(this).hasClass("panel-heading")) {
                        $(this).removeClass("clickScroll");
                        $(this).addClass("alreadyScrolled");
                    } else {
                        $(this).addClass("is-disabled");
                        //if(!$(this).hasClass("noScroll")){
                    }

                }

                if ($(this).attr("type") == "submit" && $(this).hasClass("is-submitted")) {
                    self.updateScroll(currentPageNum);
                    $(this).hide();
                }

                var currentPageBlock = $(this).parents(".pageBlock");
                var nextPageBlock = currentPageBlock.next();

                console.log(currentPageBlock);
                console.log(nextPageBlock);

                if ($(this).hasClass("autoScroll")) {
                    console.log("autoscroll");
                    if (nextPageBlock != undefined) {
                        if ($("html").hasClass("iOS")) {
                            /*if (!$(this).hasClass("is-disabled")) {
                                self.updatePrompt("scroll");
                            }*/
                        } else {
                            $('html,body').animate({
                                scrollTop: nextPageBlock.offset().top
                            }, 1000);
                        }
                    } else {
                        console.log("no next page block");
                    }
                } else {
                    console.log("no scroll");
                    //no scroll. show prompt telling them to scroll
                    if (!$(this).hasClass("is-disabled")) {
                        self.updatePrompt("scroll");
                    }
                }



            });

            //scroll if something gets hidden
            $("[data-hide-object]").on('click touchend', function(e) {

                console.log("scroll if hiding");

                var revealObj = $(this).attr('data-reveal-object');

                if (revealObj == 'undefined' || revealObj == "") {

                } else {
                    var showObj = $(this).attr("data-reveal-object");

                    if (!$("html").hasClass("iOS")) {
                        $('html,body').animate({
                            scrollTop: $(showObj).offset().top
                        }, 0);
                    }
                }
            });

            //when audio finishes
            $(".finishScroll").bind('ended', function() {
                // done playing
                console.log("audio finished");
                $("#clickScroll").trigger("click");

                $('video')[0].load();

            });

            //
            //$(window).scroll();

            console.log("trigger scroll");
            if (!$("html").hasClass("iOS")) {
                $(window).trigger('scroll');
            }

            //scroll when revealing buttons on mobile
            $('.scrollToBtn').on('touchend', function(e) {
                //console.log("thisssssssssss");
                //console.log(e);
                //console.log($(this));
                var thisObj = $(this);
                var scrollAmt = $(this).offset().top + $(this).height();
                //console.log(scrollAmt);

                $('html, body').animate({
                    scrollTop: scrollAmt
                }, 'slow', function() { $(window).trigger('resize') });

            });
			
			//if topic is complete, show all page blocks

			if (!$("body").hasClass("pHome")) {
        var preId = $("body").attr("data-pre-id");

        if (preId != undefined) {
          var groupId = "g" + preId;

          console.log(groupId);

          if (window.bazingaApp.models.api.getPageCompletion(groupId)) {
            if (
              window.bazingaApp.models.api.getPageCompletion(groupId) == "c"
            ) {
              $(".pageBlock").show();
              console.log("topic complete, show all");

              //$(".visibleClickScrollBtn").hide();
            }
          }
        }
    }

        },

        updateTimeline: function(date, barNum) {
            console.log("old updateTimeline, override " + date + "." + barNum);
        },

        //completes current section
        updateScroll: function(currentPageNum) {

            /*$('audio').each(function(){
                    this.pause(); // Stop playing
                    if(this.currentTime){
                    this.currentTime = 0; // Reset time
                    }
                });*/

            var currentPageBlock = $(".pageBlock:visible:last");
            var lastVisiblePageBlock = $(".pageBlock:visible:last");
            var lastVisiblePageBlockNum = $(lastVisiblePageBlock).attr("data-pagenum");

            console.log("update scroll-----" + currentPageNum + "/" + lastVisiblePageBlockNum);

            console.log("page you were last on: " + currentPageBlock.attr("data-pageNum"));

            //if next item is not a pageblock, show footer
            if (!currentPageBlock.next().hasClass("pageBlock")) {
                $("#footerContainer").show();
            }

            //currentPageBlock.css({'height': "auto"});

            //if has topicComplete btn, trigger it
            /*if(currentPageBlock.find(".completeTopicBtn.u-hidden").length > 0){
                $(".completeTopicBtn").trigger( "click");
            }*/

            //complete the section you were on
            var preId = $("body").attr("data-pre-id");
            var prevPageNum = currentPageBlock.attr("data-pageNum") || currentPageBlock.attr("data-pagenum");
            var pageId = parseInt(preId + prevPageNum);

            if (preId == "home") {
                pageId = "home";
            }

            console.log("NNNNNNAVVVVVVVVVV " + pageId);
            //console.log(window.bazingaApp.models.api.getNavForScreen(pageId).track.manual_completion);

            if (window.bazingaApp.models.api.getNavForScreen(pageId)) {
                if (window.bazingaApp.models.api.getNavForScreen(pageId).track.manual_completion != true) {

                    console.log("complete page: " + pageId);
                    window.bazingaApp.models.navigation.setPageCompletion("completed", pageId);
                }
            }

            var newCurrentPageBlock = currentPageBlock.next();

            console.log(currentPageBlock);
            console.log(newCurrentPageBlock);

            /*if(newCurrentPageBlock.attr("data-pageNum") == undefined){
                        console.log("no pageNum, revert to old pageBlock");
                        newCurrentPageBlock = currentPageBlock;
                };*/

            //newCurrentPageBlock = $( ".pageBlock:visible" ).last();
            if (lastVisiblePageBlockNum == currentPageNum || currentPageNum == undefined) {
                newCurrentPageBlock.show();

                var newPageId = newCurrentPageBlock.attr("data-pagenum");
                $(".parallax[data-num=" + newPageId + "]").show();

            }

            //console.log("check partblock");
            /*if($( ".pageBlock:visible" ).last().hasClass("partBlock")){
                var samePart = $( ".pageBlock:visible" ).last().attr("data-pageNum");
                //console.log("samePart "+samePart);
                $("[data-pageNum="+samePart+"]").show();
                
                //reshow next
                var newCurrentPageBlock = $( ".pageBlock:visible" ).last().next();
                newCurrentPageBlock.show();
            }*/

            var currentPageNum = newCurrentPageBlock.attr("data-pageNum");

            if (currentPageNum != undefined) {
                var newPageId = parseInt(preId + currentPageNum);

                console.log("currentPageNum " + currentPageNum);

                window.bazingaApp.models.api.setLessonLocation(newPageId); //set current page to new section that you scrolled to

                console.log("new currentPageNum " + newPageId);
            }

            if (currentPageNum != undefined) {
                window.bazingaApp.models.navigation.setParam4(currentPageNum);
                console.log("p4 is now: " + window.bazingaApp.models.navigation.getParam4());
            }

            setTimeout(function() { $("#clickScroll").removeClass("is-disabled"); }, 1000);

            //self = this;
            //self.updateProgress();

            //navigation
            //$(".navIndicator").removeClass("currentNavIndicator");
            //$( "#navContainer ul li:nth-child("+currentPageNum+") div" ).addClass("currentNavIndicator");

            //$(window).trigger('resize');

        },

        /*updateProgress:function(){
            var completedTopicPages = window.bazingaApp.models.api.getAllCompletedTopicPagesNum();
            var allTopicPages = window.bazingaApp.models.api.getAllTopicPagesNum();
            var progress = (completedTopicPages/allTopicPages)*100; 
            console.log(progress+"%");
            //$( "#progress" ).animate({width:progress+"%"});
        },*/

        isiOS: function() {

            var isIphone = navigator.userAgent.indexOf("iPhone") != -1;
            var isIpod = navigator.userAgent.indexOf("iPod") != -1;
            var isIpad = navigator.userAgent.indexOf("iPad") != -1;

            console.log("is iOS?");
            console.log(navigator.userAgent);

            // now set one variable for all iOS devices
            var isIos = isIphone || isIpod || isIpad;
            return isIos;
        },

        updatePrompt: function() {

            self = this;

            console.log("update prompt function");
            promptUp = true;
            var currentPageBlock = $(".pageBlock:visible:last");
            var currentPageNum = currentPageBlock.attr("data-pageNum");

            console.log("currentPageNum " + currentPageNum);
            console.log($(".pageBlock:visible:last").attr("data-pagenum") + " / " + $(".pageBlock:last").attr("data-pagenum"));
            //if ($(".pageBlock:visible:last").attr("data-pagenum") != $(".pageBlock:last").attr("data-pagenum")) {
            //console.log("not last, show prompt.");
            if (!$(".scrollPrompt").hasClass("expandUp")) {
                console.log("expandUp fadeIn");
                if (self.isiOS) {
                    //var scrollAmt = $(window).scrollTop() + 100;
                    $(".scrollPrompt").css("top", $("body").scrollTop() + 100);
                    $(".scrollPrompt").css("bottom", "auto");
                }
                $(".scrollPrompt").addClass("expandUp").fadeIn();
            }
            console.log("promptAvailable: " + self.promptAvailable);

            if (self.promptAvailable == true) {
                self.promptAvailable = false;

                clearTimeout(promptTimeout);
                var promptTimeout = setTimeout(function() {
                    console.log("settimeout fade prompt");
                    self.promptAvailable = true;
                    $(".scrollPrompt").removeClass("expandUp").fadeOut(); /*console.log("test");*/
                }, 2000);
            }

            //}
        },

        getQueryVariable: function(variable) {
            var query = window.location.search.substring(1);
            var vars = query.split("&");
            for (var i = 0; i < vars.length; i++) {
                var pair = vars[i].split("=");
                if (pair[0] == variable) {
                    return pair[1];
                }
            }
            return (false);
        },

        beforeAbstractLoad: function() {

        },

        abstractLoads: function() {
            //window.bazingaApp.models.navigation.setInfo('name','something');
            //console.log(window.bazingaApp.models.navigation.getInfo('name'));

        }

    });
}());